/***************************************************************************
                          core.c  -  description
                             -------------------
    begin                : Mon May 13 2002
    copyright            : (C) 2002 by Net Creature
    email                :  proxychains@users.sourceforge.net
 ***************************************************************************/
/*     GPL */
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef WIN32
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <memory.h>
#include <errno.h>
#include <netdb.h>

#include <sys/utsname.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include "core.h"
#else // WIN32
        /*
        include here windaz headers for functions:
        bzero
        inet_ntoa
        ntohs
        connect
        send
        recv
        malloc
        */
#endif

extern int __connect (int sock, const struct sockaddr *addr, socklen_t len);

static inline int analyze_response(int sock)
{
       int bytes_read=0;
       char buff[BUFF_SIZE];

       bzero(buff,sizeof(buff));

       // read header byte by byte.
       while(bytes_read<BUFF_SIZE)
       {
                if(1==recv(sock,buff+bytes_read,1,0))
                        bytes_read++;
                else
                        return SOCKET_ERROR;
                if (    bytes_read > 4     &&
                        buff[bytes_read-1]=='\n'  &&
                        buff[bytes_read-2]=='\r'  &&
                        buff[bytes_read-3]=='\n'  &&
                        buff[bytes_read-4]=='\r'  )
                        break;
       }

       // if not ok (200) or response greather than BUFF_SIZE return BLOCKED;
       if (     (bytes_read==BUFF_SIZE)  ||
                ! (     buff[9] =='2'         &&
                        buff[10]=='0'        &&
                        buff[11]=='0'         ))
                                  return BLOCKED;
       return SUCCESS;
}

static inline int tunnel_to(int sock, unsigned long ip,unsigned short port)
{
        int len;
        char buff[1024];
        bzero (buff,sizeof(buff));
        sprintf(buff,"CONNECT %s:%d HTTP/1.0\r\nUser-Agent: "
        "Mozilla/5.0\r\n\r\n",
        inet_ntoa( * (struct in_addr *) &ip),
        ntohs(port));
        len=strlen(buff);
        if(len!=send(sock,buff,len,0))
                return SOCKET_ERROR;
        return analyze_response(sock);
}
int connect_proxy_chain (
                int sock,
                unsigned long *proxy_ip,
                unsigned short *proxy_port,
                unsigned short proxy_count,
                unsigned long target_ip,
                unsigned short target_port )
{
        int i,k,retcode,*state,tcp_done,ns=-1,addr_len=0;

        struct sockaddr_in addr, local_addr;
        if(! proxy_count)
                goto error;
        state=malloc(sizeof(int)*proxy_count);
        if(!state)
                goto error;
       /*
        states: used internally by core if u want to see the chain
                0 - good ( play in chain )
                1 - can't connect to proxy
                2 - tunnelling blocked to given port
        */
        bzero(state,sizeof(int)*proxy_count);
        if(getsockname(sock ,(struct sockaddr *)&local_addr,&addr_len))
                        goto error;
        ns=sock;
again:
        printf("chain ..");fflush(stdout);
        tcp_done=0;
        // tcp connect to first availible proxy in the chain
        for(i=0;i<proxy_count;i++)
        {
                if(state[i])
                        continue;
                if(ns==-1)
                {
                        ns=socket(PF_INET,SOCK_STREAM,0);
                        if(ns==-1)
                                goto error;
///* --------------------well .... some sockets bind before us
                        if(local_addr.sin_port)
                                if(bind(ns ,(struct sockaddr *)&local_addr,
                                    addr_len=sizeof(local_addr)))
                                                goto error;
//---------- think about it :)*/
                }
                bzero(&addr,sizeof(addr));
                addr.sin_family= AF_INET;
                addr.sin_addr.s_addr=proxy_ip[i];
                addr.sin_port=proxy_port[i];
       //         printf("\nAdress: %s \n",inet_ntoa(addr.sin_addr));
                if (! __connect ( ns ,(struct sockaddr*)&addr,sizeof(addr)))
                {
                        tcp_done=1;
                        k=i;
                        break;
                }
                state[i]=1;
        }

        if(! tcp_done && i==proxy_count)
        {
                errno=ECONNREFUSED; // for nmap ;)
                goto error;
        }

        printf("..%s:%d..",
                inet_ntoa(*(struct in_addr*)&proxy_ip[i]),
                htons(proxy_port[i])
                );fflush(stdout);

        i++;  // next proxy in chain

        // tunneling through the rest of chain
        for( ;i<proxy_count;i++)
        {
                if(state[i])
                        continue;
                retcode=tunnel_to(ns,proxy_ip[i],proxy_port[i]);
                switch(retcode)
                {
                        case SUCCESS:
                                printf("..%s:%d..",
                                       inet_ntoa(*(struct in_addr*)&proxy_ip[i]),
                                       htons(proxy_port[i])
                                        );fflush(stdout);
                                        k=i;
                                        continue;
                        case BLOCKED:
                                state[i-1]=2;
                                printf("..access denied\n");
                                fflush(stdout);
                                close(ns);
                                ns=-1;
                                goto again;
                        case SOCKET_ERROR:
                                goto error;
                }
        }

        //tunnel to target
        retcode=tunnel_to(ns,target_ip,target_port);
        switch(retcode)
                {
                        case SUCCESS:
                                printf("..%s:%d\tOK\n",
                                inet_ntoa(*(struct in_addr*)&target_ip),
                                htons(target_port ));fflush(stdout);
                                break;
                        case BLOCKED:
                                printf("..access denied\n");fflush(stdout);
                                state[k]=2;
                                close(ns);
                                ns=-1;
                                goto again;
                         case SOCKET_ERROR:
                                goto error;
                }

        if(sock!=ns)
                dup2(ns,sock);
        free(state);
        return 0;
error:
        free(state);
        return -1;
}
