/***************************************************************************
                          core.h  -  description
                             -------------------
    begin                : Mon May 13 2002
    copyright          : (C) 2002 by Net Creature
    email                : proxychains@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __CORE_HEADER
#define __CORE_HEADER
#define BUFF_SIZE 8*1024  // used to read responses from poxies.
/*error codes*/
typedef enum
{
 SUCCESS=0,
 MEMORY_FAIL,        // malloc failed
 SOCKET_ERROR,  // look errno for more
 CHAIN_DOWN,    // no proxy in chain responds to tcp
 CHAIN_EMPTY,   //  if proxy_count = 0
 BLOCKED  //  target's port blocked on last proxy in the chain
} ERR_CODE;

/* connect_proxy : Connects tcp socket through http proxy using CONNECT method
* ip and port parameters in network byte order
* proxy_ip and proxy_port are arrays contaning a proxy chain
* in each of those arrays should exist at least one element.
* while connecting the chain non-responding/blocked proxies are dropped off
* blocks until connection is made
* on success returns 0
* otherwise error code returned
*/
int connect_proxy_chain (
                int sock,
                unsigned long *proxy_ip,
                unsigned short *proxy_port,
                unsigned short proxy_count,
                unsigned long target_ip,
                unsigned short target_port );

#endif
