/***************************************************************************
                          libproxychains.c  -  description
                             -------------------
    begin                : Tue May 14 2002
    copyright            : (C) 2002 by Net Creature
    email                : proxychains@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <memory.h>
#include <errno.h>
#include <netdb.h>

#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/fcntl.h>

#include "core.h"

extern int __connect (int sock, const struct sockaddr *addr, socklen_t len);

static inline void get_chain_data(
                                unsigned long *ip,
                                unsigned short *port,
                                int *len)
{

        int count=0,port_n=0;
        char buff[1024],type[1024],host[1024];
        FILE* file;

        sprintf(buff,"%s/.proxychains/proxychains.conf",getenv("HOME"));

        if(!(file=fopen(buff,"r")))
                if(!(file=fopen("/etc/proxychains.conf","r")))
                {
                        perror("1");
                        exit(1);
                }
        while(fgets(buff,sizeof(buff),file))
        {

                if(strncmp(buff,"#",1))
	  {
                        sscanf(buff,"%s %s %d", type,host,&port_n);
                        ip[count]=inet_addr(host);
                        port[count]=htons((unsigned short)port_n);
                        count++;
                }

        }
        *len=count;
        fclose(file);
}

static inline void free_chain_data(
                                unsigned long *ip,
                                unsigned short *port,
                                int *len)
{
/*
        if (*len)
        {
                free(*ip);
                *ip=NULL;
                free(*port);
                *port=NULL;
        }*/
}



#define     satosin(x)      ((struct sockaddr_in *) &(x))
#define     SOCKADDR(x)     (satosin(x)->sin_addr.s_addr)
#define     SOCKPORT(x)     (satosin(x)->sin_port)
#define     SOCKFAMILY(x)     (satosin(x)->sin_family)
#define     MAX_CHAIN 30

int connect (int sock, const struct sockaddr *addr, socklen_t len)
{
  unsigned long ip[MAX_CHAIN];
  unsigned short port[MAX_CHAIN];
  int socktype=0,optlen=0,chain_len=0,flags=0,ret=0;
  optlen=sizeof(socktype);

 // check if we have to set up chain
// printf("family %d : we look for %d\n",SOCKFAMILY(*addr),AF_INET);
 getsockopt(sock,SOL_SOCKET,SO_TYPE,&socktype,&optlen);
// printf("socktype %d : we look for %d\n",socktype,SOCK_STREAM);
 if (! (SOCKFAMILY(*addr)==AF_INET  && socktype==SOCK_STREAM))
             return __connect(sock,addr,len);   // we don't have to
  // get technical data about our chain
  get_chain_data(ip,port,&chain_len);
//  printf("trace\n");

flags=fcntl(sock, F_GETFL, 0);
//printf("flags=%d ->",fcntl(sock, F_GETFL, 0));

if(flags & O_NONBLOCK)  //  non-blocking back to blocking
        fcntl(sock, F_SETFL, !O_NONBLOCK);
//printf("flags=%d\n",fcntl(sock, F_GETFL, 0));
ret=connect_proxy_chain(
                sock,
                ip,
                port,
                chain_len,
                SOCKADDR(*addr),
                SOCKPORT(*addr)
                 );
//printf("flags=%d ->",fcntl(sock, F_GETFL, 0));
if(flags & O_NONBLOCK)  //  restore origin
        fcntl(sock, F_SETFL, flags);
//printf("flags=%d\n",fcntl(sock, F_GETFL, 0));
free_chain_data(ip,port,&chain_len);
   return ret;
}
